# Introduction to Correlation Analysis
#
# Authors: Harold Valdivia-Garica
#          Mei Nagappan

library(ggplot2)
library(GGally)
library(corrplot)
library(PerformanceAnalytics)
setwd("/Users/meido/Desktop/Research/Courses/Waterloo/CS846/stats-for-se")

do.main = function(){
	ds = read.csv("correlation-example.csv")
	head(ds)
	
	# Different relationships
	# ============== =========
	par(mfrow=c(2,2))  # split the screen in 2x2
	plot(ds$X1, ds$X2) 
	plot(ds$X1, ds$X3) 
	plot(ds$X1, ds$X4) 
	plot(ds$X1, ds$X5) 

	# What is correlation?
	# pearson --> linear-relationship
	# spearman  --> rank-correlation
	# ==================
	rho12 = cor(ds$X1, ds$X2)
	rho13 = cor(ds$X1, ds$X3)
	rho14 = cor(ds$X1, ds$X4)
	rho15 = cor(ds$X1, ds$X5)

	# Add the correlation value
	# =========================
	par(mfrow=c(2,2))
	
	plot(ds$X1, ds$X2)
	title(rho12)
	
	plot(ds$X1, ds$X3)
	title(rho13)
	
	plot(ds$X1, ds$X4)
	title(rho14)
	
	plot(ds$X1, ds$X5)
	title(rho15)
	
	# pairs
	# ======
	pairs(ds)  #,upper.panel=panel.pearson)
	cor(ds)
	
	# Real example
	# ============
	dd = read.csv("cassandra-ds.csv")
	head(dd)

	# Three different ways to plot a correlation-matrix
	pairs(dd)  
	chart.Correlation(dd, histogram=FALSE)
	corrplot(cor(dd), type="upper", method="ellipse")
}



do.main()



