# Introduction to Linear Regression
#
# Authors: Harold Valdivia-Garica
#          Mei Nagappan

library(ggplot2)
library(GGally)
library(corrplot)
library(PerformanceAnalytics)

# add a blue line in a plot previously displayed
addline1 = function(){
	xs = c(-50:1300)
	lines(xs, 30 + 0.08*xs, col="blue", lwd=2)
}

# add a green line in a plot previously displayed
addline2 = function(){
	xs =c(-50:1300)
	lines(xs, + 10 + 0.15*xs, col="green", lwd=3)
}
setwd("/Users/meido/Desktop/Research/Courses/Waterloo/CS846/stats-for-se")
do.main = function(){
	dd = read.csv("cassandra-ds.csv")
	
	# Show the correlations again
	chart.Correlation(dd, histogram=FALSE)
	
	# plot lines vs cyclomatic
	# ========================
	plot(x=dd$lines, y=dd$cyclomatic)
	addline1()
	addline2()
	
	# Find the linear model Y = B0 + B1*X1
	#   cyclomatic = B0 + B1*lines
	# ====================================
	our_model = lm(cyclomatic~lines, data=dd)
	summary(our_model)
	abline(our_model, col="red", lwd=3)  # Include the best line
	                                     # in the plot

	# More complicate
	#   num_issues = B0 + B1*lines + B2*num_commits + B3*churn
	# =============== 
	lm_num_bugs = lm(num_issues~lines+num_commits+churn,data=dd)
	summary(lm_num_bugs)
}

do.main()