# Introduction to Logistic Regression
#
# Authors: Harold Valdivia-Garica
#          Mei Nagappan

library(ggplot2)
library(GGally)
library(corrplot)
library(PerformanceAnalytics)
setwd("/Users/meido/Desktop/Research/Courses/Waterloo/CS846/stats-for-se")
do.main = function(){
	dd = read.csv("cassandra-ds.csv")
	
	# Add a column "buggy" where:
	#     buggy = 1  if num_issues > 0
	#     buggy = 0  if num_issues == 0    
	# =================================
	dd$buggy = ifelse(dd$num_issues > 0, 1, 0)
	
	# Find the logistic model
	# =======================
	logit_num_bugs <- glm(buggy ~ lines + num_commits, data = dd, family = "binomial")
	summary(logit_num_bugs)
	
	# Get the accuracy to measure 
	# the godness of our model
	# ==========================
	probs = predict(logit_num_bugs)
	dd$ypred = ifelse(probs >= 0.5, 1, 0)
	
	# Errors of our model in the training data
	num_errors = sum(abs(dd$buggy - dd$ypred))
	
	# Accuracy
	acc = num_errors/nrow(dd)
	
	# Plot buggy and non-buggy files
	# using two metrics: lines and num_commits
	# ==============================
	p = ggplot(dd, aes(x=lines, y=num_commits,group=buggy)) + geom_point(aes (color = buggy),  size=3) 
	print(p)
	
	# Plot buggy and non-buggy files predicted 
	# by our logistic model
	# ========================================
	p=ggplot(dd, aes(x=lines, y=num_commits,group=ypred)) +
		geom_point(aes (color = ypred),  size=3) 
	print(p)
}

do.main()